/*
 * Program do elektronicznego zamka
 * Na podstawie przykładu "READNUID" znajdującego się w bibliotece MFRC522 library dostępnej pod adresem https://github.com/miguelbalboa/rfid 
 * Modyfikacja: Patryk Mądry 
 * Mikrokontroler.pl 
 * 2017
 * 
*/

#define LED_Zielona 6 // Pin do którego będzie podłączona Zielona dioda
#define LED_Czerwona  7  //Pin do którego będzie podłączona czerwona dioda

#include <SPI.h>
#include <MFRC522.h>

#define SS_PIN 10
#define RST_PIN 9
 
MFRC522 rfid(SS_PIN, RST_PIN); // Instance of the class

const byte poprawna_karta[] = {0x10,0x55,0x60,0x89};


void setup() { 
  Serial.begin(9600);
  SPI.begin(); // Init SPI bus
  rfid.PCD_Init(); // Init MFRC522 
  pinMode(LED_Zielona,OUTPUT); // Ustawienie pinu LED_Zielona  jako wyjscie
  pinMode(LED_Czerwona,OUTPUT); // Ustawienie pinu LED_Czerwona jako wyjscie
    
}
 
void loop() {

  // Look for new cards
  if ( ! rfid.PICC_IsNewCardPresent()) 
    return;

  // Verify if the NUID has been readed
  if ( ! rfid.PICC_ReadCardSerial())
    return;

 
  if (rfid.uid.uidByte[0] == poprawna_karta[0] || 
      rfid.uid.uidByte[1] == poprawna_karta[1] || 
      rfid.uid.uidByte[2] == poprawna_karta[2] || 
      rfid.uid.uidByte[3] == poprawna_karta[3] ) 
     {
      
          Serial.println("Poprawna karta");  
          digitalWrite(LED_Zielona,HIGH);
          delay(1500);
          digitalWrite(LED_Zielona,LOW);
    
    
  }
  else 
  {
          Serial.println("Niepoprawna karta!!!");
          digitalWrite(LED_Czerwona,HIGH);
          delay(2000);
          digitalWrite(LED_Czerwona,LOW);
    
  }
  
  // Halt PICC
  rfid.PICC_HaltA();

  // Stop encryption on PCD
  rfid.PCD_StopCrypto1();
}



